package dev.shadowsoffire.apotheosis.adventure.socket.gem;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Preconditions;
import com.google.common.base.Strings;
import com.google.common.collect.ImmutableSet;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.function.BiFunction;
import net.minecraft.network.FriendlyByteBuf;

public final class GemClass extends Record {
  private final String key;
  
  private final Set<LootCategory> types;
  
  public static Codec<dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass> CODEC;
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemClass;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #20	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemClass;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemClass;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #20	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemClass;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemClass;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #20	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/adventure/socket/gem/GemClass;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public String key() {
    return this.key;
  }
  
  public Set<LootCategory> types() {
    return this.types;
  }
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)Codec.STRING.fieldOf("key").forGetter(dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass::key), (App)LootCategory.SET_CODEC.fieldOf("types").forGetter(dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass::types)).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass::new));
  }
  
  public GemClass(String key, Set<LootCategory> types) {
    this.key = key;
    this.types = types;
    Preconditions.checkArgument(!Strings.isNullOrEmpty(this.key), "Invalid GemClass with null key");
    Preconditions.checkArgument((this.types != null && !this.types.isEmpty()), "Invalid GemClass with null or empty types");
  }
  
  public void write(FriendlyByteBuf buf) {
    buf.m_130070_(this.key);
    buf.writeByte(this.types.size());
    this.types.forEach(c -> buf.m_130070_(c.getName()));
  }
  
  public static dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass read(FriendlyByteBuf buf) {
    String key = buf.m_130277_();
    int size = buf.readByte();
    List<LootCategory> list = new ArrayList<>(size);
    for (int i = 0; i < size; i++)
      list.add(LootCategory.byId(buf.m_130277_())); 
    return new dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass(key, (Set<LootCategory>)ImmutableSet.copyOf(list));
  }
}
